/*̧قDoxygenpɏĂ܂B*/
//! \file *********************************************************************
//!
//! \brief USBʎq
//!
//!  ̧ق͋Lqq\ʂĉpBɎʂUSBҰ܂݂܂B
//!
//! - ߲		: AVRpIAR EWAVRGNU GCC
//! - x޲	: AT90USB1287, AT90USB1286, AT90USB647, AT90USB646
//!
//! \author	Atmel Corporation	: http://www.atmel.com \n
//!			xFAQ			: http://support.atmel.no/
//!
//! ***************************************************************************

/* 쌠 (c) 2007, Atmel Corporation S\ς݁B
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. ATMEL̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * ATMELɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂATMEL̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂATMELɐӔC
 * Ȃł傤B
 */

#ifndef _USB_DESCRIPTORS_H_
#define _USB_DESCRIPTORS_H_

/*_____ ݸٰ _____________________________________________________________*/

#include "config.h"
#include "modules/usb/device_chap9/usb_standard_request.h"
#include "conf_usb.h"

/*_____ ϸ _________________________________________________________________*/

#define Usb_get_dev_desc_pointer()	(&(usb_dev_desc.bLength))
#define Usb_get_dev_desc_length()	(sizeof (usb_dev_desc))
#define Usb_get_conf_desc_pointer()	(&(usb_conf_desc.cfg_mouse.bLength))
#define Usb_get_conf_desc_length()	(sizeof (usb_conf_desc))

/*_____ USB` _____________________________________________________________*/

// USBuLqq
#define USB_SPECIFICATION	0x0200
#define DEVICE_CLASS		0				// e`Ԑݒ͂ꎩg̸׽܂B
#define DEVICE_SUB_CLASS	0				// e`Ԑݒ͂ꎩg̕׽܂B
#define DEVICE_PROTOCOL		0				// e`Ԑݒ͂ꎩg̋K܂B
#define EP_CONTROL_LENGTH	64
#define VENDOR_ID			VID_ATMEL
#define PRODUCT_ID			PID_AT90USB128_64_MS
#define RELEASE_NUMBER		0x1000
#define MAN_INDEX			0x01
#define PROD_INDEX			0x02
#if (USB_DEVICE_SN_USE==ENABLE)
#define SN_INDEX			0x03
#else
#define SN_INDEX			0x00			// ʔԗ̈Ȃ
#endif
#define NB_CONFIGURATION	1

// `Ԑݒ
#define NB_INTERFACE		1				// ̪
#define CONF_NB				1
#define CONF_INDEX			0
#define CONF_ATTRIBUTES		USB_CONFIG_BUSPOWERED
#define MAX_POWER			50				// 100mA

// USBeʋL̪Lqq
#define INTERFACE_NB		0				// ̪ԍ
#define ALTERNATE			0
#define NB_ENDPOINT			2
#define INTERFACE_CLASS		MS_CLASS		// eʋL׽
#define INTERFACE_SUB_CLASS	MS_SUB_CLASS6	// SCSIߖ߈ꎮ
#define INTERFACE_PROTOCOL	MS_PROTOCOL		// ʓ]̂
#define INTERFACE_INDEX		0

// USB߲2LqqFS
#define ENDPOINT_NB_2		(EP_MS_IN | USB_ENDPOINT_IN)
#define EP_ATTRIBUTES_2		0x02			// =0x02,荞=0x03
#define EP_IN_LENGTH		64
#define EP_SIZE_2			EP_IN_LENGTH
#define EP_INTERVAL_2		0x00

// USB߲3LqqFS
#define ENDPOINT_NB_3		EP_MS_OUT
#define EP_ATTRIBUTES_3		0x02			// =0x02,荞=0x03
#define EP_IN_LENGTH		64
#define EP_SIZE_3			EP_IN_LENGTH
#define EP_INTERVAL_3		0x00

#define DEVICE_STATUS		USB_DEVICE_STATUS_BUS_POWERED

#define LANG_ID				0x00

#define USB_MN_LENGTH		5
#define USB_MANUFACTURER_NAME \
{
	Usb_unicode('A'), \
	Usb_unicode('T'), \
	Usb_unicode('M'), \
	Usb_unicode('E'), \
	Usb_unicode('L')  \
}

#define USB_PN_LENGTH		22
#define USB_PRODUCT_NAME \
{
	Usb_unicode('A'), \
	Usb_unicode('V'), \
	Usb_unicode('R'), \
	Usb_unicode(' '), \
	Usb_unicode('U'), \
	Usb_unicode('S'), \
	Usb_unicode('B'), \
	Usb_unicode(' '), \
	Usb_unicode('M'), \
	Usb_unicode('S'), \
	Usb_unicode(' '), \
	Usb_unicode('F'), \
	Usb_unicode('I'), \
	Usb_unicode('L'), \
	Usb_unicode('E'), \
	Usb_unicode(' '), \
	Usb_unicode('S'), \
	Usb_unicode('Y'), \
	Usb_unicode('S'), \
	Usb_unicode('T'), \
	Usb_unicode('E'), \
	Usb_unicode('M')  \
}

#define USB_SN_LENGTH		0x0D
// ʔԂ͍Œ12łׂłB
#define USB_SERIAL_NUMBER \
{
	Usb_unicode('0'), \
	Usb_unicode('0'), \
	Usb_unicode('0'), \
	Usb_unicode('0'), \
	Usb_unicode('0'), \
	Usb_unicode('0'), \
	Usb_unicode('0'), \
	Usb_unicode('0'), \
	Usb_unicode('0'), \
	Usb_unicode('0'), \
	Usb_unicode('0'), \
	Usb_unicode('0'), \
	Usb_unicode('0')  \
}

#define LANGUAGE_ID			0x0409

//! USBv
typedef struct
{
	U8	bmRequestType;						//!< v̓
	U8	bRequest;							//!< w肷v
	U16	wValue;								//!< vɏ]ĕω̈
	U16	wIndex;								//!< vɏ]ĕω̈
	U16	wLength;							//!< ް̏ꍇ͓]޲Đ
} S_UsbRequest;

//! USBuLqq
typedef struct
{
	U8	bLength;							//!< ޲Ăł̂̋Lqq̑傫
	U8	bDescriptorType;					//!< uLqq`
	U16	bscUSB;								//!< Jdl2i10il
	U8	bDeviceClass;						//!< USBɂĊ蓖Ăꂽ׽
	U8	bDeviceSubClass;					//!< USBɂĊ蓖Ăꂽ׽
	U8	bDeviceProtocol;					//!< USBɂĊ蓖ĂꂽK񕄍
	U8	bMaxPacketSize0;					//!< EP0ɑ΂ő߹ėe
	U16	idVendor;							//!< ID(ATMEL=0x03EB)
	U16	idProduct;							//!< Ǝ҂ɂĊ蓖ĂꂽiID
	U16	bcdDevice;							//!< uJԍ
	U8	iManufacturer;						//!< ƎҕLqq̎wW
	U8	iProduct;							//!< iLqq̎wW
	U8	iSerialNumber;						//!< ʔԕLqq̎wW
	U8	bNumConfigurations;					//!< \Ȍ`Ԑݒ萔
} S_usb_device_descriptor;

//! USB`ԐݒLqq
typedef struct
{
	U8	bLength;							//!< ޲Ăł̂̋Lqq̑傫
	U8	bDescriptorType;					//!< `ԐݒLqq`
	U16	wTotalLength;						//!< Ԃް̍v
	U8	bNumInterfaces;						//!< ̌`Ԑݒɑ΂̪
	U8	bConfigurationValue;				//!< SetConfigurationvɑ΂l
	U8	iConfiguration;						//!< Lqq̎wW
	U8	bmAttibutes;						//!< `Ԑݒ
	U8	MaxPower;							//!< őd
} S_usb_configuration_descriptor;

//! USB̪Lqq
typedef struct
{
	U8	bLength;							//!< ޲Ăł̂̋Lqq̑傫
	U8	bDescriptorType;					//!< ̪Lqq`
	U8	bInterfaceNumber;					//!< ̪
	U8	bAlternateSetting;					//!< ֐ݒI邽߂̒l
	U8	bNumEndpoints;						//!< EP0߲(EP)
	U8	bInterfaceClass;					//!< USBɂĊ蓖Ăꂽ׽
	U8	bInterfaceSubClass;					//!< USBɂĊ蓖Ăꂽ׽
	U8	bInterfaceProtocol;					//!< USBɂĊ蓖ĂꂽK񕄍
	U8	iInterface;							//!< Lqq̎wW
} S_usb_interface_descriptor;

//! USB߲ċLqq
typedef struct
{
	U8	bLength;							//!< ޲Ăł̂̋Lqq̑傫
	U8	bDescriptorType;					//!< ߲ċLqq`
	U8	bEndpointAddress;					//!< ߲Ă̱ڽ
	U8	bmAttributes;						//!< ߲Ă̑
	U16	wMaxPacketSize;						//!< EPɑ΂ő߹ėe
	U8	bInterval;							//!< msłEP߰ݸފԊu
} S_usb_endpoint_descriptor;

//! USBLqq
typedef struct
{
	U8	bLength;							//!< ޲Ăł̂̋Lqq̑傫
	U8	bDescriptorType;					//!< Lqq`
	U16	wlangid;							//!< ID
} S_usb_language_id;

//_____ USBƎҋLqq ___________________________________________________

// usb_st_manufacturer\
typedef struct
{
	U8	bLength;							// ޲Ăł̂̋Lqq̑傫
	U8	bDescriptorType;					// Lqq`
	U16	wstring[USB_MN_LENGTH];				// ƺޕ
} S_usb_manufacturer_string_descriptor;

//_____ USBiLqq _______________________________________________________

// usb_st_product\
typedef struct
{
	U8	bLength;							// ޲Ăł̂̋Lqq̑傫
	U8	bDescriptorType;					// Lqq`
	U16	wstring[USB_PN_LENGTH];				// ƺޕ
} S_usb_product_string_descriptor;

//_____ USBʔԋLqq _______________________________________________________

#if (USB_DEVICE_SN_USE==ENABLE)
// usb_st_serial_number\
typedef struct
{
	U8	bLength;							// ޲Ăł̂̋Lqq̑傫
	U8	bDescriptorType;					// Lqq`
#if (USE_DEVICE_SN_UNIQUE==ENABLE)

#else
	U16	wstring[USB_SN_LENGTH];				// ƺޕ
#endif
} S_usb_serial_number;
#endif

typedef struct
{
	S_usb_configuration_descriptor	cfg_mouse;
	S_usb_interface_descriptor		ifc_ms;
	S_usb_endpoint_descriptor		ep1_ms;
	S_usb_endpoint_descriptor		ep2_ms;
} S_usb_user_configuration_descriptor;

#endif
