/*̧قDoxygenpɏĂ܂B*/
//! \file *********************************************************************
//!
//! \brief ̧قUSBνčƊ֐p̊֐`܂݂܂B
//!
//! - ߲		: AVRpIAR EWAVRGNU GCC
//! - x޲	: AT90USB1287, AT90USB1286, AT90USB647, AT90USB646
//!
//! \author	Atmel Corporation	: http://www.atmel.com \n
//!			xFAQ			: http://support.atmel.no/
//!
//! ***************************************************************************

/* 쌠 (c) 2007, Atmel Corporation S\ς݁B
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. ATMEL̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * ATMELɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂATMEL̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂATMELɐӔC
 * Ȃł傤B
 */

#ifndef _USB_HOST_TASK_H_
#define _USB_HOST_TASK_H_

/*_____ ݸٰ _____________________________________________________________*/

#if (USB_HUB_SUPPORT==ENABLE)
#include "modules/usb/host_chap9/usb_host_hub.h"
#endif

/*_____ ^ __________________________________________________________________*/

typedef struct
{
	bit enable;
	U16 nb_byte_to_process;
	U16 nb_byte_processed;
	U16 nb_byte_on_going;
	U8 *ptr_buf;
	void(*handle)(U8 status, U16 nb_byte);
	U8 status;
	U8 timeout;
	U16 nak_timeout;
} S_pipe_int;

/*_____ ϸ _________________________________________________________________*/

#define PIPE_GOOD			   0
#define PIPE_DATA_TOGGLE	0x01
#define PIPE_DATA_PID		0x02
#define PIPE_PID			0x04
#define PIPE_TIMEOUT		0x08
#define PIPE_CRC16			0x10
#define PIPE_STALL			0x20
#define PIPE_NAK_TIMEOUT	0x40
#define PIPE_DELAY_TIMEOUT	0x80

//! @defgroup usb_host_task USBνč
//! @{

	//! @brief uڑƐ(ڑF)ꂽTRUEԂ܂B
	//! νďʉp͐ڑꂽu։̉pvsOɂ𒲂ׂׂłB
	#define Is_host_ready()			((device_state==DEVICE_READY) ? TRUE : FALSE)

	//! ʉpuւ̗vsȂTRUEԂ܂B
	#define Is_host_not_ready()		((device_state==DEVICE_READY) ? FALSE :TRUE)

	//! νĐ킪x~(Suspend)삩
	#define Is_host_suspended()		(((device_state==DEVICE_WAIT_RESUME) ||(device_state==DEVICE_SUSPENDED)) ? TRUE : FALSE)

	//! νĐ킪x~(Suspend)łȂ
	#define Is_host_not_suspended()	(((device_state==DEVICE_WAIT_RESUME) ||(device_state==DEVICE_SUSPENDED)) ? FALSE : TRUE)

	//! νĂɐؒfꂽu邩
	#define Is_host_unattached()	((device_state==DEVICE_UNATTACHED) ? TRUE : FALSE)

	//! νĂɐڑꂽu邩
	#define Is_host_attached()		((device_state>=DEVICE_UNATTACHED) ? TRUE : FALSE)

	//! ̊֐νĐUSBx~(Suspend)ֈڍs邽߂ɌĂ΂ׂłB
	#define Host_request_suspend()	(device_state=DEVICE_SUSPENDED)

	//! ̊֐USB޽ĊJ邱ƂνĂ֗v邽߂ɌĂ΂ׂłB
	#define Host_request_resume()	(request_resume=TRUE)

	//! ĳۂɑ΂鎄I
	#define Host_ack_request_resume()	(request_resume=FALSE)

	//! ڑꂽűؾĂ()(ڑF)
	#define Host_force_enumeration()	(force_enumeration=TRUE, device_state=DEVICE_ATTACHED, init_usb_tree())

	//! ĊJ菇ɑ΂鎄I
	#define Is_host_request_resume()	((request_resume==TRUE)   ? TRUE : FALSE)

	//! Vu(ڑF)ꂽTRUEԂB
	#define Is_new_device_connection_event()	(new_device_connected ? TRUE : FALSE)

	//! νĂ瑕uؒfꂽTRUEԂB
#if (USB_HUB_SUPPORT==ENABLE)
  #define Is_device_disconnection_event()	((device_state==DEVICE_DISCONNECTED_ACK || device_state==DEVICE_DISCONNECTED || f_hub_port_disconnect) ? TRUE : FALSE)
#else
  #define Is_device_disconnection_event()	((device_state==DEVICE_DISCONNECTED_ACK || device_state==DEVICE_DISCONNECTED) ? TRUE : FALSE)
#endif

	//! ߲߂ɕtS荞݂~
	#define Host_stop_pipe_interrupt(i) (\
			Host_disable_transmit_interrupt(), \
			Host_disable_receive_interrupt(), \
			Host_disable_stall_interrupt(), \
			Host_disable_error_interrupt(), \
			Host_disable_nak_interrupt(), \
			Host_reset_pipe(i))

	//! @defgroup device_state_value νĐ
	//! uԕp`
	//! \image html host_task.gif
	//! @{
	#define DEVICE_UNATTACHED				0
	#define DEVICE_ATTACHED					1
	#define DEVICE_POWERED					2
	#define DEVICE_DEFAULT					3
	#define DEVICE_ADDRESSED				4
	#define DEVICE_CONFIGURED				5
	#define DEVICE_READY					6

	#define DEVICE_ERROR					7

	#define DEVICE_SUSPENDED				8
	#define DEVICE_WAIT_RESUME				9

	#define DEVICE_DISCONNECTED				10
	#define DEVICE_DISCONNECTED_ACK			11

	#define Host_set_device_supported()		(device_status |=  0x01)
	#define Host_clear_device_supported()	(device_status &= ~0x01)
	#define Is_host_device_supported()		(device_status &   0x01)

	#define Host_set_device_ready()			(device_status |=  0x02)
	#define Host_clear_device_ready()		(device_status &= ~0x02)
	#define Is_host_device_ready()			(device_status &   0x02)

	#define Host_set_configured()			(device_status |=  0x04)
	#define Host_clear_configured()			(device_status &= ~0x04)
	#define Is_host_configured()			(device_status &   0x04)

	#define Host_clear_device_status()		(device_status =   0x00)
	//! @}

/*_____ 錾 ________________________________________________________________*/

/**
 * @brief ̊֐USBνēŁAƒgϐĊ荞
 * ݂܂B
 *
 * ̊֐USBνē`ԗpɋ܂B
 *
 * @param	Ȃ
 *
 * @return	Ȃ
 *
 */
void usb_host_task_init (void);

/**
 * @brief νĊǗ̓_
 *
 * _͑u(device_state)ɉđuڕWڑƗ(ڑF)Ǘ邱
 * ƂŁA֐͑u̗񋓂ƌ`Ԑݒ𓾂̂ɕKvȑs܂B
 * UuɂȂƁAdevice_stateDEVICE_READYłB
 * ̏Ԃ͑uɂǂ̉pvŝɂ旧νčƉpɂČ
 * ׂłB
 * ̊֐͌ݑIĂUSB`(u܂ν)Ɉˑusb_task֐
 * Ă΂܂B
 *
 * @param	Ȃ
 *
 * @return	Ȃ
 *
 */
void usb_host_task (void);

/**
  * @brief ̊֐͎w肳ꂽ߲ߔԍ*bufŎwnb_data𑗂܂B
  *
  * @note ̊֐͎Ԓ߂o邽߂νSOF荞݂ɂ܂B荞݋SOF͕܂B
  * interrupt enable sof will be restore.
  *
  * @param	pipe
  * @param	nb_data
  * @param	buf
  *
  * @return	(0OK)
  */
U8 host_send_data (U8 pipe, U16 nb_data, U8 *buf);

/**
  * @brief ̊֐͎w肳ꂽ߲ߔԍ*bufŎwnb_data󂯎܂B
  *
  * nb_dataҰU16߲ƂēnA]Ă߲ɂĎwꂽް
  * ͎󂯎ŏIIް ޲ĐōXV܂B
  *
  * @note ̊֐͎Ԓ߂o邽߂νSOF荞݂ɂ܂B
  * ݋SOF܂B
  *
  * @param	pipe
  * @param	nb_data
  * @param	buf
  *
  * @return	(0OK)
  */
U8 host_get_data (U8 pipe, U16 *nb_data, U8 *buf);

U8 host_get_data_interrupt (U8 pipe, U16 nb_data, U8 *buf, void (*handle)(U8 status, U16 nb_byte));

U8 host_send_data_interrupt (U8 pipe, U16 nb_data, U8 *buf, void (*handle)(U8 status, U16 nb_byte));

void reset_it_pipe_str (void);

U8 is_any_interrupt_pipe_active (void);

extern U8 device_state;
extern U8 request_resume;
extern U8 new_device_connected;
extern U8 force_enumeration;

//! @}

#endif /* _USB_HOST_TASK_H_ */
